#!/usr/bin/perl -w
################################################################################
#                                                                              #
#  2DHF version 5-2005                                                         #
#  Copyright (C) 2005  Jacek Kobus                                             #
#                                                                              #
#  This software may be used and distributed according to the terms            #
#  of the GNU General Public License, see README and COPYING.                  #
#                                                                              #
################################################################################

# 02/2005
# This script modifies source files as follows:
# integer*4           --> integer*8
# implicit integer*4  --> implicit integer*8
# real*8              --> real*16
# implicit real*8     --> implicit real*16

# It may happen that routine ttime will need an individual treatment.

open (ALLFILES, "ls *.f *.c *.raw *.inc|");

@allfiles=<ALLFILES>;
$allfiles_nb=@allfiles-1;

for ($i=0; $i<=$allfiles_nb; $i++) {
    open(FILE,"cat $allfiles[$i] |") || die "cannot open ", $allfiles[$i];
    @file=<FILE>;
    $file_nb=@file-1;
    close(FILE);
    open(FILE,">$allfiles[$i]") || die "cannot open ", $allfiles[$i];
    for ($j=0; $j<=$file_nb; $j++) {
	$t=$file[$j];

	if ($allfiles[$i] =~ /main-dynamic/) {
	    $t =~ s/8\*length1/16\*length1/;
	    $t =~ s/8\*length2/16\*length2/;
	    $t =~ s/8\*length3/16\*length3/;
	    $t =~ s/8\*length4/16\*length4/;
	    $t =~ s/8\*length5/16\*length5/;
	    $t =~ s/4\*length6/8\*length6/;
	}

	if ($allfiles[$i] =~ /rheader/) {
	    if ( $t =~ /integer\*4 i4tmp1,i4tmp2/ ) {
		print (FILE $t);
		next;
	    }
	}

	if ($allfiles[$i] =~ /rfun/) {
	    if ( $t =~ /integer\*4 i4tmp\(9750\)/ ) {
		print (FILE $t);
		next;
	    }

	    if ( $t =~ /real\*8 wk8\(\*\)/ ) {
		print (FILE $t);
		next;
	    }

	}

	$t =~ s/      real\*8/      real*16/;
	$t =~ s/implicit real\*8/implicit real\*16/;

	$t =~ s/      integer\*4/      integer*8/;
	$t =~ s/implicit integer\*4/implicit integer\*8/;

# some functions are not available in the 64-bit version of g77

	$t =~ s/(\s+call flush)/c$1/;
        $t =~ s/(\s+stime)/c$1/;
        $t =~ s/(\s+call ctime)/c$1/;

	print (FILE $t);
    }
    close(FILE);
};

#


