********************************************************************************
*                                                                              *
*  2DHF version 5-2005                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### lpcoeff ###  

      subroutine lpcoeff(iord,istart,k,r,coeff)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension a(12),b(12),coeff(9),r(*)

c     This routine calculates coefficients of the (sub)Lagrange 
c     polynomial for a grid point k
c     \prod_{i=1,i\ne k}^{9} {(r-r_{i}) \over (r_{k}-r_{i})}
c
c     r_{k}= r(istart+k), k=1,...,iord
c
      
c  calculate denominator product

      denom=1.d0
      do i=1,iord
         if (i.ne.k) denom=denom*(r(istart+k)-r(istart+i))
      enddo

      do i=1,12
         a(i)=0.d0
         b(i)=0.d0	 
      enddo

c     calculate nominator product: 
c     a(1)+a(2)*r+a(3)*r^2+...+a(9)*r^8
c     storing coefficients in a and b

      a(1)=1.d0

c  multiply polynomial a by (r+c1), c1=-r(istart+i)

      ic2=1	
      do i=1,iord
         if (i.ne.k) then
  	    ic2=ic2+1
            c1=-r(istart+i)	  
	    b(1)=a(1)*c1
	    do ic1=2,ic2
               b(ic1)=a(ic1)*c1+a(ic1-1)
	    enddo
            b(ic2+1)=a(ic2)	
            do j=1,ic2+1
               a(j)=b(j)
            enddo
         endif	    
      enddo   

      do i=1,iord
         coeff(i)=a(i)/denom
      enddo
      return
      end
