********************************************************************************
*                                                                              * 
*  2DHF version 5-2005                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rfun ###	
c
c     Reads functions from a disk file in an unformatted form
c
      subroutine rfun (norbt,cw_orb,cw_coul,cw_exch,wk8,wk16)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)	
      integer*4 i4tmp(9750)
      integer*8 i8tmp(9750)
      real*8 wk8(*),r8tmp1(60),r8tmp2(1200),r8tmp3(3660)
      real*8 wk16(*),r16tmp1(60),r16tmp2(1200),r16tmp3(3660)
      parameter (ione=1)

      include 'commons8.inc'

      dimension cw_orb(*),cw_coul(*),cw_exch(*)

      if (lengthint.eq.4) then
         read (iinp11,err=1000) i4tmp
      else
         read (iinp11,err=1000) i8tmp
      endif

      ioffset=norb-norbt

c     retrieve orbitals 
      do i=1,norbt
         if (lengthfp.eq.8) then
            call reada8(iinp11,i1si(i+ioffset),wk8,ierr)
            if (ierr.ne.0) then
               write(iout6,*) 'error detected when reading orbital',i
               stop 'rfun 8'
            endif				   	
            do j=1,i1si(i+ioffset)
               cw_orb(i1b(i+ioffset)+j-1)=wk8(j)
            enddo
         endif

         if (lengthfp.eq.16) then
            call reada16(iinp11,i1si(i+ioffset),wk16,ierr)
            if (ierr.ne.0) then
               write(iout6,*) 'error detected when reading orbital',i
               stop 'rfun 16'
            endif				   	
            do j=1,i1si(i+ioffset)
               cw_orb(i1b(i+ioffset)+j-1)=wk16(j)
            enddo
         endif
      enddo	   
      
c     retrieve the extra data from the orbital input file

      if (lengthfp.eq.8) then
         read(iinp11,end=1010,err=1010) r8tmp1
         do i=1,60
            area(i)=r8tmp1(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp1
         do i=1,60
            eng(i)=r8tmp1(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp1
         do i=1,60
            engo(i)=r8tmp1(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp2
         do i=1,1200
            cmulti(i)=r8tmp2(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp3
         do i=1,3660
            excdi(i)=r8tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp3
         do i=1,3660
            excqu(i)=r8tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp3
         do i=1,3660
            excoc(i)=r8tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp3
         do i=1,3660
            exche(i)=r8tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp3
         do i=1,3660
            exc5(i)=r8tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp3
         do i=1,3660
            exc6(i)=r8tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp3
         do i=1,3660
            exc7(i)=r8tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r8tmp3
         do i=1,3660
            exc8(i)=r8tmp3(i)
         enddo
      else
         read(iinp11,end=1010,err=1010) r16tmp1
         do i=1,60
            area(i)=r16tmp1(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp1
         do i=1,60
            eng(i)=r16tmp1(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp1
         do i=1,60
            engo(i)=r16tmp1(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp2
         do i=1,1200
            cmulti(i)=r16tmp2(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp3
         do i=1,3660
            excdi(i)=r16tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp3
         do i=1,3660
            excqu(i)=r16tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp3
         do i=1,3660
            excoc(i)=r16tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp3
         do i=1,3660
            exche(i)=r16tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp3
         do i=1,3660
            exc5(i)=r16tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp3
         do i=1,3660
            exc6(i)=r16tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp3
         do i=1,3660
            exc7(i)=r16tmp3(i)
         enddo
         read(iinp11,end=1010,err=1010) r16tmp3
         do i=1,3660
            exc8(i)=r16tmp3(i)
         enddo
      endif


      rewind iinp11	
     
c     read in Coulomb potentials 

      do i=1,norbt
         if (lengthfp.eq.8) then
            call reada8(iinp12,i2si(i+ioffset),wk8,ierr)
            if (ierr.ne.0) then
               write(iout6,*) 'error detected when reading coulomb',
     &              ' potential',i
               stop 'rfun 8'
            endif				   	
            do j=1,i2si(i+ioffset)
               cw_coul(i2b(i+ioffset)+j-1)=wk8(j)
            enddo
         endif
         if (lengthfp.eq.16) then
            call reada16(iinp12,i2si(i+ioffset),wk16,ierr)
            if (ierr.ne.0) then
               write(iout6,*) 'error detected when reading coulomb',
     &              ' potential',i
               stop 'rfun 16'
            endif				   	
            do j=1,i2si(i+ioffset)
               cw_coul(i2b(i+ioffset)+j-1)=wk16(j)
            enddo
         endif
      enddo	   

c     read in exchange potentials from the exhange potential input file
c     (only for HF calculations)

      if (imethod.eq.1) then
         if (iform.eq.1.or.iform.eq.3.and.ini.ne.6) then
            do iorb1=1,norbt
               do iorb2=iorb1,norbt
                  k=iorb1+iorb2*(iorb2-1)/2
                  if (iorb1.eq.iorb2.and.ll(iorb1).eq.0) goto 50

                  if (lengthfp.eq.8) then
                     call reada8(iinp13,i3si(k),wk8,ierr)
                     if (ierr.ne.0) then
                        write(iout6,*) 'error detected when reading ',
     &                       'exchange potential',iorb1,iorb2,k
                        stop 'rfun 8'
                     endif				   	
                     do j=1,i3si(k)
                        cw_exch(i3b(k)+j-1)=wk8(j)
                     enddo
                  endif
                  if (lengthfp.eq.16) then
                     call reada16(iinp13,i3si(k),wk16,ierr)
                     if (ierr.ne.0) then
                        write(iout6,*) 'error detected when reading ',
     &                       'exchange potential',iorb1,iorb2,k
                        stop 'rfun 16'
                     endif				   	
                     do j=1,i3si(k)
                        cw_exch(i3b(k)+j-1)=wk16(j)
                     enddo
                  endif
                     
                  if (iorb1.eq.iorb2) goto 50
                  if (ll(iorb1).eq.0.or.ll(iorb2).eq.0) goto 50
                  if (lengthfp.eq.8) then
                     call reada8(iinp13,i3si(k),wk8,ierr)
                     if (ierr.ne.0) then
                        write(iout6,*) 'error detected when reading ',
     &                       'exchange potential',iorb1,iorb2,k
                        stop 'rfun 8'
                     endif				   	
                     do j=1,i3si(k)
                        cw_exch(i3b(k)+i3si(k)+j-1)=wk8(j)
                     enddo
                  endif
                  if (lengthfp.eq.16) then
                     call reada16(iinp13,i3si(k),wk16,ierr)
                     if (ierr.ne.0) then
                        write(iout6,*) 'error detected when reading ',
     &                       'exchange potential',iorb1,iorb2,k
                        stop 'rfun 16'
                     endif				   	
                     do j=1,i3si(k)
                        cw_exch(i3b(k)+i3si(k)+j-1)=wk16(j)
                     enddo
                  endif
 50               continue
               enddo
            enddo
            rewind iinp13
         endif
         write(*,*) '... orbitals and potentials retrieved ... '
      endif
      return
 1000 continue
      write(*,*) '... error detected when retrieving the disk', 
     &           ' file ... '
      stop 'rfun'
      
 1010 write(*,*) '... error detected when retrieving ',
     &     'extension of the orbital input file ...'
      write(*,*) '... disk file without extension retrieved ... '
      idump=1
 1100 continue

      if(idbg(51).ne.0) then
         write(*,*)
         write(*,*) 'rfun: input orbitals'
c        print orbitals 
	 do i=1,norb
            write(*,*) iorn(i),' ',bond(i)
            call pmtx(nni,i1mu(i),cw_orb(i1b(i)),ione,ione,
     &           incrni,incrmu)
	 enddo	   
      endif
         
      if(idbg(52).ne.0) then
         write(*,*)
         write(*,*) 'rfun: input Coulomb potentials'
c        print Coulomb potential
	 do i=1,norb
            write(*,*) iorn(i),' ',bond(i)
            call pmtx(nni,i1mu(i),cw_coul(i2b(i)),ione,ione,
     &           incrni,incrmu)
	 enddo	   
      endif

      if(idbg(53).ne.0.and.nexch.ge.1) then
         write(*,*)
         write(*,*) 'rfun: input exchange potentials'
c        print exchange potentials
	 do i=1,nexch
            write(*,*) 'exchange potential ',i 
           call pmtx(nni,i1mu(i),cw_exch(i3b(i)),ione,ione,
     &           incrni,incrmu)
	 enddo	   
      endif
      
      return
      end
